package com.mh.algorithm.bpnn;

import com.mh.algorithm.matrix.Matrix;
import com.mh.algorithm.utils.CsvInfo;
import com.mh.algorithm.utils.CsvUtil;
import com.mh.algorithm.utils.SerializationUtil;
import org.junit.Test;

import java.util.Date;

public class bpnnTest {
    @Test
    public void test() throws Exception {
        // 创建训练集矩阵
        CsvInfo csvInfo = CsvUtil.getCsvInfo(true, "D:\\ljf\\my_pro\\top-algorithm-set-dev\\src\\trainDataElec.csv");
        Matrix trainSet = csvInfo.toMatrix();
        // 创建BPNN工厂对象
        BPNeuralNetworkFactory factory = new BPNeuralNetworkFactory();
        // 创建BP参数对象
        BPParameter bpParameter = new BPParameter();
        bpParameter.setInputLayerNeuronCount(2);
        bpParameter.setHiddenLayerNeuronCount(2);
        bpParameter.setOutputLayerNeuronCount(2);
        bpParameter.setPrecision(0.01);
        bpParameter.setMaxTimes(10000);

        // 训练BP神经网络
        System.out.println(new Date());
        BPModel bpModel = factory.trainBP(bpParameter, trainSet);
        System.out.println(new Date());

        // 将BPModel序列化到本地
        SerializationUtil.serialize(bpModel, "elec");

        CsvInfo csvInfo2 = CsvUtil.getCsvInfo(true, "D:\\ljf\\my_pro\\top-algorithm-set-dev\\src\\testDataElec.csv");
        Matrix testSet = csvInfo2.toMatrix();

        Matrix testData1 = testSet.subMatrix(0, testSet.getMatrixRowCount(), 0, testSet.getMatrixColCount() - 2);
        Matrix testLabel = testSet.subMatrix(0, testSet.getMatrixRowCount(), testSet.getMatrixColCount() - 2, 1);
        // 将BPModel反序列化
        BPModel bpModel1 = (BPModel) SerializationUtil.deSerialization("elec");
        Matrix result = factory.computeBP(bpModel1, testData1);

        int total = result.getMatrixRowCount();
        int correct = 0;
        for (int i = 0; i < result.getMatrixRowCount(); i++) {
            if(Math.round(result.getValOfIdx(i,0)) == testLabel.getValOfIdx(i,0)){
                correct++;
            }
        }
        double correctRate = Double.valueOf(correct) / Double.valueOf(total);
        System.out.println(correctRate);
    }

    /**
     * 使用示例
     * @throws Exception
     */
    @Test
    public void bpnnUsing() throws Exception{
        CsvInfo csvInfo = CsvUtil.getCsvInfo(false, "D:\\ljf\\my_pro\\top-algorithm-set-dev\\src\\dataElec.csv");
        Matrix data = csvInfo.toMatrix();
        // 将BPModel反序列化
        BPModel bpModel1 = (BPModel) SerializationUtil.deSerialization("elec");
        // 创建工厂
        BPNeuralNetworkFactory factory = new BPNeuralNetworkFactory();
        Matrix result = factory.computeBP(bpModel1, data);
        CsvUtil.createCsvFile(null,result,"D:\\ljf\\my_pro\\top-algorithm-set-dev\\src\\computeResult.csv");
    }

}
