package com.mh.user.factory;

import com.mh.user.entity.DeviceCodeParamEntity;
import com.mh.user.strategy.DeviceStrategy;
import lombok.extern.slf4j.Slf4j;

/**
 * @author LJF
 * @version 1.0
 * @project CHWS
 * @description 电表设备
 * @date 2024-03-15 16:52:39
 */
@Slf4j
public class EleMeter implements Device {

    private DeviceStrategy eleMeterStrategy;

    private static class SingletonHolder {
        private static final EleMeter INSTANCE = new EleMeter();
    }

    private EleMeter() {
        // 防止外部直接实例化
    }

    public static EleMeter getInstance() {
        return EleMeter.SingletonHolder.INSTANCE;
    }

    @Override
    public void setStrategy(DeviceStrategy strategy) {
        this.eleMeterStrategy = strategy;
    }

    @Override
    public String createOrders(DeviceCodeParamEntity deviceCodeParamEntity) {
        log.info("电表设备创建报文");
        return eleMeterStrategy.createOrders(deviceCodeParamEntity);
    }

    @Override
    public String analysisReceiveData(String dateStr, String deviceType, String registerAddr, String brand, String buildingId, String buildingName, String dataStr) {
        return eleMeterStrategy.analysisReceiveData(dateStr, deviceType, registerAddr, brand, buildingId, buildingName, dataStr);
    }
}
