package com.mh.user.factory;

import com.mh.user.entity.DeviceCodeParamEntity;
import com.mh.user.strategy.DeviceStrategy;
import lombok.extern.slf4j.Slf4j;

/**
 * @author LJF
 * @version 1.0
 * @project CHWS
 * @description 状态检测
 * @date 2024-03-15 17:07:54
 */
@Slf4j
public class StatusCheck implements Device {

    private DeviceStrategy wtMeterStrategy;

    private static class SingletonHolder {
        private static final StatusCheck INSTANCE = new StatusCheck();
    }

    private StatusCheck() {
        // 防止外部直接实例化
    }

    public static StatusCheck getInstance() {
        return SingletonHolder.INSTANCE;
    }


    @Override
    public void setStrategy(DeviceStrategy strategy) {
        this.wtMeterStrategy = strategy;
    }

    @Override
    public String createOrders(DeviceCodeParamEntity deviceCodeParamEntity) {
        log.info("水表设备创建报文");
        return wtMeterStrategy.createOrders(deviceCodeParamEntity);
    }

    @Override
    public String analysisReceiveData(String dateStr, String deviceType, String registerAddr, String brand, String buildingId, String buildingName, String dataStr) {
        return wtMeterStrategy.analysisReceiveData(dateStr, deviceType, registerAddr, brand, buildingId, buildingName, dataStr);
    }
}
