package com.mh.user.factory;

import com.mh.user.entity.DeviceCodeParamEntity;
import com.mh.user.strategy.DeviceStrategy;

/**
 * @author LJF
 * @version 1.0
 * @project CHWS
 * @description 温度控制器
 * @date 2024-03-18 16:53:35
 */
public class TempControl implements Device {

    private DeviceStrategy strategy;

    private static class SingletonHolder {
        private static final TempControl INSTANCE = new TempControl();
    }

    private TempControl() {
        // 防止外部直接实例化
    }

    public static TempControl getInstance() {
        return TempControl.SingletonHolder.INSTANCE;
    }

    @Override
    public void setStrategy(DeviceStrategy strategy) {
        this.strategy = strategy;
    }

    @Override
    public String createOrders(DeviceCodeParamEntity deviceCodeParamEntity) {
        return strategy.createOrders(deviceCodeParamEntity);
    }

    @Override
    public String analysisReceiveData(String dateStr, String deviceType, String registerAddr, String brand, String buildingId, String buildingName, String dataStr) {
        return strategy.analysisReceiveData(dateStr, deviceType, registerAddr, brand, buildingId, buildingName, dataStr);
    }
}
