package com.mh.user.service;

import com.mh.user.dto.EnergyPreDTO;
import com.mh.user.dto.EnergyPreEchartDataDTO;
import com.mh.user.dto.EnergyPreTopDataDTO;
import com.mh.user.entity.HistoryDataPre;

import java.util.HashMap;
import java.util.List;

/**
 * @author LJF
 * @version 1.0
 * @project CHWS
 * @description 预测历史数据服务类
 * @date 2024-05-09 10:02:54
 */
public interface HistoryDataPreService {

    /**
     * 获取训练数据
     * @param buildingId
     * @throws Exception
     */
    void startTrainData(String buildingId) throws Exception;

    /**
     * 开始预测数据
     * @param buildingId
     * @param curDate
     * @throws Exception
     */
    void startPredictData(String buildingId, String curDate) throws Exception;

    /**
     * 获取每栋楼的数据
     * @param buildingId
     * @param curDate
     * @return
     */
    List<HistoryDataPre> getRecentData(String buildingId, String curDate);

    /**
     * 获取预测数据
     * @param buildingId
     * @param beginDate
     * @param endDate
     * @param type
     * @return
     */
    List<HashMap<String, Object>> getEnergyPre(String buildingId, String beginDate, String endDate, String type);

    List<EnergyPreTopDataDTO> getTopData(String buildingId, String type);
}
