package com.mh.user.service.impl;

import com.github.pagehelper.PageHelper;
import com.mh.common.page.ColumnFilter;
import com.mh.common.page.MybatisPageHelper;
import com.mh.common.page.PageRequest;
import com.mh.common.page.PageResult;
import com.mh.user.entity.KnowledgeDataEntity;
import com.mh.user.mapper.KnowledgeDataMapper;
import com.mh.user.service.KnowledgeDataService;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;

/**
 * @author LJF
 * @version 1.0
 * @project CHWS
 * @description 知识库服务实现类
 * @date 2024-06-26 14:33:20
 */
@Service
public class KnowledgeDataServiceImpl implements KnowledgeDataService {

    @Resource
    private KnowledgeDataMapper knowledgeDataMapper;

    @Override
    public void insertKnowledgeData(KnowledgeDataEntity knowledgeData) {
        knowledgeDataMapper.insertKnowledgeData(knowledgeData);
    }

    @Override
    public PageResult queryKnowledgeData(PageRequest pageRequest) {
        return MybatisPageHelper.findPage(pageRequest, knowledgeDataMapper);
    }

    @Override
    public void updateData(KnowledgeDataEntity knowledgeData) {
        knowledgeDataMapper.updateData(knowledgeData);
    }

    @Override
    public KnowledgeDataEntity getById(Long id) {
        return knowledgeDataMapper.getById(id);
    }
}
