package com.mh.user;

import com.mh.user.entity.EnergyEntity;
import com.mh.user.mapper.EnergyMapper;
import com.mh.user.mapper.DealDataMapper;
import com.mh.user.model.BuildingModel;
import com.mh.user.service.BuildingService;
import com.mh.user.service.HistoryDataPreService;
import com.mh.user.service.NowDataService;
import com.mh.user.utils.ExchangeStringUtil;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;

import java.util.List;

/**
 * @author ljf
 * @title ：
 * @description ：
 * @updateTime 2020-07-28
 * @throws ：
 */
public class DealDataTest extends UserServiceApplicationTests {

    @Autowired
    private DealDataMapper dealDataMapper;
    @Autowired
    private NowDataService nowDataService;

    @Autowired
    private EnergyMapper energyMapper;

    @Test
    public void dealChillersData() {
//        dealDataMapper.dealChillersData();
    }

    @Test
    public void testSetTemp(){
        nowDataService.upTempSet2("33","48","2");
    }

    @Test
    public void getDataTest(){
        List<EnergyEntity> list = energyMapper.queryEnergyMonth("2-3", "2023-03", "2023-03", 1, 10);
        System.out.println(list);
    }

    @Autowired
    private HistoryDataPreService historyDataPreService;
    
    @Autowired
    private BuildingService buildingService;

    @Test
    public void testPre() {
//        try {
//            // 训练数据
//            historyDataPreService.startTrainData("21");
//            // 预测数据
//            historyDataPreService.startPredictData("21", "2024-11-19");
//        } catch (Exception e) {
//            e.printStackTrace();
//            System.out.println(e.getMessage());
//        }
        List<BuildingModel> buildingModels = buildingService.selectBuildingName();
        for (BuildingModel buildingModel : buildingModels) {
            String buildingId = String.valueOf(buildingModel.getBuildingId());
            if ("21".equals(buildingId) || "24".equals(buildingId) || "25".equals(buildingId)) {
                continue;
            }
            for (int i = 1; i < 20; i++) {
                String curDate = "2024-11-" + ExchangeStringUtil.addZeroForNum(String.valueOf(i), 2);
                try {
                    // 训练数据
                    historyDataPreService.startTrainData(buildingId);
                    // 预测数据
                    historyDataPreService.startPredictData(buildingId, curDate);
                } catch (Exception e) {
                    e.printStackTrace();
                }
            }

        }
    }
}
